#ifndef _F__TRACE_H_
#define _F__TRACE_H_

#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <assert.h>
//#include <iostream>
#include <fstream>
#include <windows.h> // Required before including winbase :(
#include <winbase.h> // For SYSTEMTIME

#include "file/file.h"
#define LOGFILENAME ".\\log.txt"


//////////////////////////////////////////////////////////////
#ifndef NOTRACE
	#define PUSHSTACK(x)			StackTrace st(x,__FILE__,__LINE__);
	#define TRACE(x)				FTrace::GetInstance()->Log(x);
#define STOP_TRACE() 		delete FTrace::GetInstance();
#else
	#define PUSHSTACK(x)	
	#define TRACE(x)		
#endif
//////////////////////////////////////////////////////////////

using namespace std;

class FTrace
{
public:

	static FTrace * GetInstance();

	static void IncrementStackDepth() { m_nCurStackDepth++; }
	static void DecrementStackDepth() { m_nCurStackDepth--; }
	static int  GetStackDepth()		  { return m_nCurStackDepth; }
	
	void Log(const char*);
	
	~FTrace();

private:
	FTrace();
	File * logFile;
	static FTrace * pivInstance;

	static int m_nCurStackDepth;
	
	void GetDateString(char * destString);

};

class StackTrace
{
public:
	StackTrace(const char*,const char* szFileName="unknown", int nLine = 42);

	~StackTrace();

private:
	char m_szFuncName[100];
	SYSTEMTIME m_StartTime;
};


#endif